#include<stdio.h>
#include<math.h>
#include<alloc.h>
#include<process.h>


struct node
{ int info;
  struct node * link;
};

typedef struct node * nptr;


//fn that returns jth digit of the item
int seperate(int item,int j)
{ return item/(int)pow(10,j-1) %10;
}


int largest(int a[],int n)
{ int i,big;
  big = a[0];
  for(i=1;i<n;i++)
  { if(a[i]>big) big = a[i];
  }
  return big;
}


nptr getnode()
{ nptr x = (nptr) malloc(sizeof(struct node));
  if(!x) printf("out of mem");
return x;
}


nptr insert_rear(int item,nptr first)
{ nptr temp,cur;

  temp = getnode();
  temp->info = item;
  temp->link = NULL;

  if(!first) return temp;

  cur = first;
  while(cur->link)
  { cur=cur->link;
  }

  cur->link = temp;

  return first;
}



void radix_sort(int a[],int n)
{ int i,j,k,m,big,digit;
  nptr p[10],temp;

  big = largest(a,n);
  m = log10(big) + 1;

  for(j=1;j<=m;j++)
  {  for(i=0;i<=9;i++)
     p[i] = NULL;

     for(i=0;i<n;i++)
     { digit = seperate(a[i],j);
       p[digit] = insert_rear(a[i],p[digit]);
     }

     k=0;
     for(i=0;i<=9;i++)
     { temp = p[i];
       while(temp)
       { a[k++] = temp->info;
	 temp = temp->link;
       }
     }
  }
}



void main()
{ int n,i,a[20];

  scanf("%d",&n);

  for(i=0;i<n;i++)
  scanf("%d",&a[i]);

  radix_sort(a,n);

  for(i=0;i<n;i++)
  printf("%d ",a[i]);

}
